<template>
<!--解除行政强制措施决定书-->
  <el-main>
    <el-form ref="form" :model="form" :disabled="form.registerState == '1'">
      <el-form-item label="文号" :label-width="formLabelWidth">
        <el-input
          v-model="form.unitName"
          placeholder="_______解强决〔    〕第    号"
        ></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="当事人姓名 " :label-width="formLabelWidth">
            <el-input v-model="form.litigant" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="实施强制措施时间"
            :label-width="formLabelWidth"
          >
            <el-date-picker
              v-model="form.enforcementTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="强制措施文号 " :label-width="formLabelWidth">
            <el-input
              v-model="form.decisionUnitName"
              placeholder="_______强措决〔    〕第    号"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="解除时间" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.releaseTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="联系人 " :label-width="formLabelWidth">
            <el-input
              v-model="form.contact"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话 " :label-width="formLabelWidth">
            <el-input
              v-model="form.phone"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="印章日期" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.executionTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center;">
      <el-button v-show="form.registerState != '1'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-show="form.registerState != '1'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import WordView from "@/views/News/word-view";
import {getObj, saveObj} from "@/api/News/relieveForceDecide";
import moment from "moment";

export default {
  name: "relieveForceDecide",
  props: ['isShowYulan','id','isFinish','processId','title'],
  components: {
    WordView
  },
  data() {
    return {
      showView: false,
      form: {
        unitName: "",
        decisionUnitName:"",
        litigant: "",
        enforcementTime: "",
        releaseTime: "",
        contact: "",
        phone: "",
        executionTime:'',
      },
      formLabelWidth: "140px",
    };
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      getObj(this.id).then((res) => {
          // 转换null为""
          let v = res.data.data;
          for (let attr in v) {
              if (v[attr] == null) {
                  v[attr] = "";
              }
          }
          let str = JSON.stringify(v);
          let data = JSON.parse(str);
          this.form = data;
      });
    },
    dataFormSubmit(type) {
      console.log(type)
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/relieveForceDecide.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/relieveForceDecide.docx", this.title+'.docx');
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);
      if (data.enforcementTime != '' && data.enforcementTime != null) {
        data.enforcementTime = moment(data.enforcementTime).format('YYYY年MM月DD日');
      }else {
        data.enforcementTime = '  年  月  日'
      }

      if (data.releaseTime != '' && data.releaseTime != null) {
        data.releaseTime = moment(data.releaseTime).format('YYYY年MM月DD日');
      }else {
        data.releaseTime = '  年  月  日'
      }

      if (data.executionTime != '' && data.executionTime != null) {
        data.executionTime = moment(data.executionTime).format('YYYY年MM月DD日');
      }else {
        data.executionTime = '  年  月  日'
      }



      return data;
    }
  }
}
</script>

<style scoped>

</style>
